EXT_INT2:	;  -  300  (  ).
	push	Temp
	in	Temp, SREG
	push	Temp
	push	Tmp
	push	ZH
	push	ZL

	mov	Temp, reNoiseImmunity;       .
	sbic 	PINB, PINB2 	;    , 
	rjmp 	Exit_EXT_INT2	;reNoiseImmunity,    
	dec	Temp		;     ,  
	brne 	PC-3		;     .

  	in	Temp, GICR	;      
	cbr	Temp, 1<<INT2	; - .   
	out	GICR, Temp	;    .

	out	OCR2, reDelayBeforeOn;     (        ).
	clr	Temp
	out	TCNT2, Temp	; (, ) .
	in	Temp, SFIOR	;  .
	sbr	Temp, PSR2
	out	SFIOR, Temp
	in	Temp, TCCR2
	sbr	Temp, (1<<CS21)	;       8.
	out	TCCR2, Temp
	sbr	rBit, 1<<bTimer2Mode; ,       .
  
  	sbrs	rBit, bSoftTurn1;  ,   
	rjmp	CheckButton1	;   .
	sbrs	rBit, bIsChannel1On;  ,    .
	rjmp	SoftTurnOff1

	sbrs	rBit2, bChannel1Mode;      .
	rjmp	Channel1Mode1	;  ,  
	cp	reLastBright1_2, rBrightness1;     , 
	brne	SoftTurnOn1	;             .
	mov	rBrightness1, reLastBright1_2;   
	rjmp	SoftTurnOn1Completed

Channel1Mode1:	
	cp	reLastBright1_1, rBrightness1
	brne	SoftTurnOn1	
	mov	rBrightness1, reLastBright1_1

SoftTurnOn1Completed:
	cbr	rBit, 1<<bSoftTurn1;   
	sbr	reBit, (1<<ebPowerState1);    .
	rjmp	GoOut1		;        .

SoftTurnOn1:
	inc	rBrightness1	;       .
	rjmp	GoOut1		

SoftTurnOff1:
	dec	rBrightness1	;       .
	breq	SoftTurnOff1Completed;     ,
	rjmp	GoOut1
SoftTurnOff1Completed:
	cbr	rBit, 1<<bSoftTurn1;   ,
	cbr	reBit, (1<<ebPowerState1);   ,
	cbr	rBit2, 1<<bChannel1Mode;    ,
	rjmp	Channel1Completed;     1- .

CheckButton1:			;    .
	sbic	pKeyboardIn, sbFirstChannel;  , 
	rjmp	Button1IsOff

	ldi	Temp, eBrightChangeDelay1
	rcall	EEPROM_Read
	inc	rButton1PushedTime;    
	cp	rButton1PushedTime, Temp;       eeprom .
	brlo	IsChannel1On	;    eBrightChangeDelay
	sbrc	rBit, bIsChannel1On;  ,
	rjmp	ChangeBrightness1;    .
	sbr	rBit2, 1<<bChannel1Mode;  ,   
	rjmp	Turn1	;    .

ChangeBrightness1:	
	mov	Tmp, Temp	;        rButton1PushedTime.
	ldi	Temp, eBrightChangeSpeed1;     
	rcall	EEPROM_Read	;     
	sub	Tmp, Temp	;eBrightChangeDelay  eBrightChangeSpeed.
	mov	rButton1PushedTime, Tmp
	sbrs	rBit, bIsChannel1On;  ,    
	rjmp	Channel1Completed;   .
	
	sbrc	rBit, bBritnessVector1;  ,   ,
	rjmp	IncreaseBrightness1; - .
	dec	rBrightness1
	brne	GoOut1
	ldi	rBrightness1, 1
	sbr	rBit, 1<<bBritnessVector1
	rjmp	GoOut1

IncreaseBrightness1:
	inc	rBrightness1	;    .    .  
	brne	GoOut1		;(rBrightness1    0),      .
	ldi	rBrightness1, 254; -     , 
	cbr	rBit, 1<<bBritnessVector1;   ,
	rjmp	GoOut1		;      .
	
Button1IsOff:			;    (    ).
	cpi	rButton1PushedTime, 0;    
	breq	IsChannel1On	; ,     .
	ldi	Temp, eTurnDuration1;     (..     )
	rcall	EEPROM_Read	;      .
	cp	rButton1PushedTime, Temp;    
	ldi	rButton1PushedTime, 0;(    eTurnDuration),
	brlo	Turn1		;     .
	sbrs	reBit,ebBrightDirMode1;     
	rjmp	IsChannel1On	;ebBrightDirMode=1,     
	sbr	rBit, 1<<bBritnessVector1;   
	rjmp	IsChannel1On	; ,   .

Turn1:
	sbrc	rBit, bIsChannel1On;   (bIsChannel1On=0)
	rjmp	Turn1Off	;    .
	sbr	rBit, (1<<bIsChannel1On)+(1<<bSoftTurn1)
	sbr	rBit, 1<<bBritnessVector1
	clr	rBrightness1	;         .
	rjmp	Channel1Completed

Turn1Off:
	cbr	rBit, 1<<bIsChannel1On
	sbr	rBit, 1<<bSoftTurn1
	sbrs	rBit2, bChannel1Mode
	rjmp	SaveBrightness1_1
	mov	reLastBright1_2, rBrightness1;     
	rjmp 	GoOut1		;   eeprom,     .
SaveBrightness1_1:
	mov	reLastBright1_1, rBrightness1
	rjmp 	GoOut1		

IsChannel1On:
	sbrs	rBit, bIsChannel1On;     
	rjmp	Channel1Completed; .

GoOut1:
	ldi	ZH, HIGH(2*NormalizedBrightness)
	ldi	ZL, LOW(2*NormalizedBrightness)
	add	ZL, rBrightness1; rBrightness   
	clr	Temp		;  .
	adc	ZH, Temp
	lpm	rCh1OffTime, Z	;   rCh1OffTime        .
;-----------------------------------------------------------------------------      	
Channel1Completed:
	sbrs	rBit, bSoftTurn2
	rjmp	CheckButton2
	sbrs	rBit, bIsChannel2On
	rjmp	SoftTurnOff2

	sbrs	rBit2, bChannel2Mode
	rjmp	Channel2Mode1
	cp	reLastBright2_2, rBrightness2
	brne	SoftTurnOn2
	mov	rBrightness2, reLastBright2_2
	rjmp	SoftTurnOn2Completed

Channel2Mode1:	
	cp	reLastBright2_1, rBrightness2
	brne	SoftTurnOn2	
	mov	rBrightness2, reLastBright2_1

SoftTurnOn2Completed:
	cbr	rBit, 1<<bSoftTurn2
	sbr	reBit, (1<<ebPowerState2)
	rjmp	GoOut2
	
SoftTurnOn2:
	inc	rBrightness2
	rjmp	GoOut2

SoftTurnOff2:
	dec	rBrightness2
	breq	SoftTurnOff2Completed
	rjmp	GoOut2

SoftTurnOff2Completed:
	cbr	rBit, 1<<bSoftTurn2
	cbr	reBit, (1<<ebPowerState2)
	cbr	rBit2, 1<<bChannel2Mode
	rjmp	GoOut

CheckButton2:
	sbic	pKeyboardIn, sbSecondChannel
	rjmp	Button2IsOff

	ldi	Temp, eBrightChangeDelay2
	rcall	EEPROM_Read
	inc	rButton2PushedTime
	cp	rButton2PushedTime, Temp
	brlo	IsChannel2On
	sbrc	rBit, bIsChannel2On
	rjmp	ChangeBrightness2
	sbr	rBit2, 1<<bChannel2Mode
	rjmp	Turn2
	
ChangeBrightness2:
	mov	Tmp, Temp
	ldi	Temp, eBrightChangeSpeed2
	rcall	EEPROM_Read
	sub	Tmp, Temp
	mov	rButton2PushedTime, Tmp
	sbrs	rBit, bIsChannel2On
	rjmp	GoOut
	
	sbrc	rBit, bBritnessVector2
	rjmp	IncreaseBrightness2
	dec	rBrightness2
	brne	GoOut2
	ldi	rBrightness2, 1
	sbr	rBit, 1<<bBritnessVector2
	rjmp	GoOut2

IncreaseBrightness2:
	inc	rBrightness2
	brne	GoOut2
	ldi	rBrightness2, 254
	cbr	rBit, 1<<bBritnessVector2
	rjmp	GoOut2
	
Button2IsOff:
	cpi	rButton2PushedTime, 0
	breq	IsChannel2On
	ldi	Temp, eTurnDuration2
	rcall	EEPROM_Read
	cp	rButton2PushedTime, Temp
	ldi	rButton2PushedTime, 0
	brlo	Turn2
	sbrs	reBit, ebBrightDirMode2
	rjmp	IsChannel2On
	sbr	rBit, 1<<bBritnessVector2
	rjmp	IsChannel2On

Turn2:
	sbrc	rBit, bIsChannel2On
	rjmp	Turn2Off
	sbr	rBit, (1<<bIsChannel2On)+(1<<bSoftTurn2)
	cbr	rBit, 1<<bBritnessVector2
	clr	rBrightness2
	rjmp	GoOut

Turn2Off:
	cbr	rBit, 1<<bIsChannel2On
	sbr	rBit, 1<<bSoftTurn2
	sbrs	rBit2, bChannel2Mode
	rjmp	SaveBrightness2_1
	mov	reLastBright2_2, rBrightness2
	rjmp 	GoOut2
SaveBrightness2_1:
	mov	reLastBright2_1, rBrightness2
	rjmp 	GoOut2

IsChannel2On:
	sbrs	rBit, bIsChannel2On
	rjmp	GoOut

GoOut2:
	ldi	ZH, HIGH(2*NormalizedBrightness)
	ldi	ZL, LOW(2*NormalizedBrightness)
	add	ZL, rBrightness2
	clr	Temp
	adc	ZH, Temp
	lpm	rCh2OffTime, Z
;-----------------------------------------------------------------------------
GoOut:
	ldi	Temp, eLastBright1_1;         
	mov	Tmp, reLastBright1_1;          ,
	rcall	EepromWriteIfDifferent;        eeprom.
	ldi	Temp, eLastBright1_2;         
	mov	Tmp, reLastBright1_2;          ,
	rcall	EepromWriteIfDifferent;        eeprom.
	ldi	Temp, eLastBright2_1
	mov	Tmp, reLastBright2_1
	rcall	EepromWriteIfDifferent
	ldi	Temp, eLastBright2_2
	mov	Tmp, reLastBright2_2
	rcall	EepromWriteIfDifferent
	ldi	Temp, eBit	;       reBit
	mov	Tmp, reBit	;     eeprom,
	rcall	EepromWriteIfDifferent;   reBit  eeprom.

	in	Temp, pMainOut	;   .

	cpi	rCh1OffTime, 0	; rCh1OffTime   
	breq	Channel2Out	;  ,
	sbr	Temp, 1<<bChannel1;   .

Channel2Out:
	cpi	rCh2OffTime, 0
	breq	ChannelsOut
	sbr	Temp, 1<<bChannel2

ChannelsOut:
	mov	rOutChannels, Temp

Exit_EXT_INT2:
	pop	ZL
	pop	ZH
	pop	Tmp
	pop	Temp
	out	SREG, Temp
	pop	Temp
	reti
;*****************************************************************************
TIM2_COMP:
;    34  (     ).
;!     38.    1
;        38-34=4!
;   ,    , 
;        ,
;    (  cTimer2Freq).

	push	Temp
	in	Temp, SREG
	push	Temp

	sbrc	rBit, bTimer2Mode;  ,       ,
	rjmp	DelayBeforeOn	; -   .

	in	Temp, pMainOut

	cpi	rCh1OffTime, 0	;   ,    ,
	breq	Ch2Off		;      .
	dec	rCh1OffTime	;    1.
	brne	Ch2Off		;      0,   
	cbr	Temp, 1<<bChannel1;    1    .

Ch2Off:	cpi	rCh2OffTime, 0	;    5 
	breq	GoChannelsOut	;(    ).
	dec	rCh2OffTime
	brne	GoChannelsOut
	cbr	Temp, 1<<bChannel2

GoChannelsOut:
	out	pMainOut, Temp

	andi 	Temp, 0b00000011;  .
	cpi	Temp, 0		;    (Temp=0),
	brne	Exit_TIM2_COMP	; 
	in	Temp, TCCR2	; 
	cbr	Temp, (1<<CS22)+(1<<CS21)+(1<<CS20)
	out	TCCR2, Temp
	in	Temp, GICR	;   
	sbr	Temp, 1<<INT2	; 
	out	GICR, Temp	;    .
	in	Temp, GIFR	;C  
	sbr	Temp, 1<<INTF2	;   - 
	out	GIFR, Temp	;       .
	rjmp	Exit_TIM2_COMP


DelayBeforeOn:
	out	pMainOut, rOutChannels	; .

	in	Temp, TCCR2
	cbr	Temp, (1<<CS22)+(1<<CS21)+(1<<CS20) ; .
	out	TCCR2, Temp
	ldi	Temp, cTimer2Freq;   , 
	out	OCR2, Temp	;  .
	clr	Temp		; (, ) .
	out	TCNT2, Temp
	in	Temp, SFIOR
	sbr	Temp, PSR2	;  .
	out	SFIOR, Temp
	in	Temp, TCCR2
	sbr	Temp, (1<<CS20)	;     
	out	TCCR2, Temp	; .
	cbr	rBit, 1<<bTimer2Mode; ,       .

Exit_TIM2_COMP:
	pop	Temp
	out	SREG, Temp
	pop	Temp
	reti
